/*
** CCTDE - Covert Channels and Tunnels Detection Engine - v0.2
** Copyright (C) 2003,2004 Simon Castro - scastro@entreelibre.com
**
** This file is part of CCTDE - v0.2 (C) 2003,2004 Simon Castro.
** 
** Cctde is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctde is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctde; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#define ALERT_UPCON 0
#define ALERT_MAX 1
#define ALERT_ADV 2

#define ALERT_SRV 0
#define ALERT_CL  1

typedef struct s_correlator_alert_adv {
  int cmp1; // con,uptime,prx,ptx,brx,btx
  int cmp2; // con,uptime,prx,ptx,brx,btx
  int nbcmp1;
  int mul;
  int res;
  u_int32_t dal;
  u_int32_t pal;
  u_int32_t silent;
  u_int32_t weight;
} t_correlator_alert_adv;

typedef struct s_correlator_alert_max {
  int label; // con,uptime,prx,ptx,brx,btx
  u_int32_t max;
  u_int32_t dal;
  u_int32_t pal;
  u_int32_t silent;
  u_int32_t weight;
} t_correlator_alert_max;

typedef struct s_correlator_alert {
  int NUM;
  int alert_type;
  int cl_or_srv;
  t_correlator_alert_adv alert_adv;
  t_correlator_alert_max alert_max;
} t_correlator_alert;

/* correlator_upcon.c */

int upcon_detect_uptime(t_con_track *ptr);
int upcon_detect_packets_amount(t_con_track *ptr);
int upcon_detect_bytes_amount(t_con_track *ptr);

/* correlator_advanced.c */
int advanced_alerts(t_correlator_alert *stored_alert, t_storage *stored_view, char *cl_or_srv);

/* correlator_max.c */
int alert_dal_and_pal(t_storage *stored_view, u_int32_t NUM, u_int32_t check_val,u_int32_t reminder_dal, u_int32_t reminder_pal, u_int32_t silent);
int max_alerts(t_correlator_alert *stored_alert, t_storage *stored_view, char *cl_or_srv);

/* correlator.c */
int correlate_upcon(t_con_track *ptr);
int generic_stats_client(t_correlator_alert *stored_alert, t_storage *stored_view);
int generic_stats_server(t_correlator_alert *stored_alert, t_storage *stored_view);
int correlate_client(t_storage *stored_view, void *rien);
int correlate_server(t_storage *stored_view, void *rien);
int correlate_and_alert();

int remove_alert_rules(char *function, char *params, int flag);
int display_alert_rules(char *function, char *params, int flag);

void display_alerts_infos(t_correlator_alert *alert);

