/*
** CCTDE - Covert Channels and Tunnels Detection Engine - v0.2
** Copyright (C) 2003,2004 Simon Castro - scastro@entreelibre.com
**
** This file is part of CCTDE - v0.2 (C) 2003,2004 Simon Castro.
** 
** Cctde is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctde is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctde; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

typedef struct s_stats_infos {
  time_t time_first;
  time_t time_last;
  u_int32_t timeline_nb;
  u_int32_t delay;
} t_stats_infos;

typedef struct s_stats {
  t_stats_infos stats_infos;
  
  // Next both values are not for unique clients nor servers !
  u_int32_t cl_number;
  u_int32_t srv_number;

  u_int32_t tcp_nb;
  u_int32_t packet_rx;
  u_int32_t packet_tx;
  u_int32_t bytes_rx;
  u_int32_t bytes_tx;
  u_int32_t com_uptime;

  u_int32_t topX_srv_tcp_nb[2];
  u_int32_t topX_srv_packet_rx[2];
  u_int32_t topX_srv_packet_tx[2];
  u_int32_t topX_srv_bytes_rx[2];
  u_int32_t topX_srv_bytes_tx[2];
  u_int32_t topX_srv_com_uptime[2];
  u_int32_t topX_srv_alert[2];

  u_int32_t topX_cl_tcp_nb[2];
  u_int32_t topX_cl_packet_rx[2];
  u_int32_t topX_cl_packet_tx[2];
  u_int32_t topX_cl_bytes_rx[2];
  u_int32_t topX_cl_bytes_tx[2];
  u_int32_t topX_cl_com_uptime[2];
  u_int32_t topX_cl_srv[2];
  u_int32_t topX_cl_alert[2];
} t_stats;

t_stats G_stats;

/* stats.h */
int stats_clients(t_storage *client_storage, void *rien);
void stats_timeline(t_time_storage *time_storage);
int build_average_stats();
void stats_topxsrv_con(t_storage *infos);
void stats_topxsrv_uptime(t_storage *infos);
void stats_topxsrv_prx(t_storage *infos);
void stats_topxsrv_ptx(t_storage *infos);
void stats_topxsrv_brx(t_storage *infos);
void stats_topxsrv_btx(t_storage *infos);

void stats_topxcl_con(t_storage *infos);
void stats_topxcl_uptime(t_storage *infos);
void stats_topxcl_prx(t_storage *infos);
void stats_topxcl_ptx(t_storage *infos);
void stats_topxcl_brx(t_storage *infos);
void stats_topxcl_btx(t_storage *infos);

/* stats_display.h */
void stats_display_server_ip_port(t_storage *infos);
void stats_display_client_ip(t_storage *infos);
void display_stats_generic();
void display_stats_topx_server();
void display_stats_approx();
int display_average_stats();
