/*
** CCTDE - Covert Channels and Tunnels Detection Engine - v0.2
** Copyright (C) 2003,2004 Simon Castro - scastro@entreelibre.com
**
** This file is part of CCTDE - v0.2 (C) 2003,2004 Simon Castro.
** 
** Cctde is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctde is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctde; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/cctde.h"

void stats_topxsrv_con(t_storage *infos)
{
  G_stats.topX_srv_tcp_nb[0] += 1;
  G_stats.topX_srv_tcp_nb[1] += infos->tcp_nb;
}
void stats_topxcl_con(t_storage *infos)
{
  G_stats.topX_cl_tcp_nb[0] += 1;
  G_stats.topX_cl_tcp_nb[1] += infos->tcp_nb;
}

void stats_topxsrv_uptime(t_storage *infos)
{
  G_stats.topX_srv_com_uptime[0] += 1;
  G_stats.topX_srv_com_uptime[1] += infos->com_uptime;
}
void stats_topxcl_uptime(t_storage *infos)
{
  G_stats.topX_cl_com_uptime[0] += 1;
  G_stats.topX_cl_com_uptime[1] += infos->com_uptime;
}

void stats_topxsrv_prx(t_storage *infos)
{
  G_stats.topX_srv_packet_rx[0] += 1;
  G_stats.topX_srv_packet_rx[1] += infos->packet_rx;
}
void stats_topxcl_prx(t_storage *infos)
{
  G_stats.topX_cl_packet_rx[0] += 1;
  G_stats.topX_cl_packet_rx[1] += infos->packet_rx;
}

void stats_topxsrv_ptx(t_storage *infos)
{
  G_stats.topX_srv_packet_tx[0] += 1;
  G_stats.topX_srv_packet_tx[1] += infos->packet_tx;
}
void stats_topxcl_ptx(t_storage *infos)
{
  G_stats.topX_cl_packet_tx[0] += 1;
  G_stats.topX_cl_packet_tx[1] += infos->packet_tx;
}

void stats_topxsrv_brx(t_storage *infos)
{
  G_stats.topX_srv_bytes_rx[0] += 1;
  G_stats.topX_srv_bytes_rx[1] += infos->bytes_rx;
}
void stats_topxcl_brx(t_storage *infos)
{
  G_stats.topX_cl_bytes_rx[0] += 1;
  G_stats.topX_cl_bytes_rx[1] += infos->bytes_rx;
}

void stats_topxsrv_btx(t_storage *infos)
{
  G_stats.topX_srv_bytes_tx[0] += 1;
  G_stats.topX_srv_bytes_tx[1] += infos->bytes_tx;
}
void stats_topxcl_btx(t_storage *infos)
{
  G_stats.topX_cl_bytes_tx[0] += 1;
  G_stats.topX_cl_bytes_tx[1] += infos->bytes_tx;
}

void stats_topxcl_srv(t_storage *infos)
{
  G_stats.topX_cl_srv[0] += 1;
  G_stats.topX_cl_srv[1] += infos->sec_list_qt;
}

void stats_topxsrv_alert(t_storage *infos)
{
  G_stats.topX_srv_alert[0] += 1;
  G_stats.topX_srv_alert[1] += infos->total_alerts;
}
void stats_topxcl_alert(t_storage *infos)
{
  G_stats.topX_cl_alert[0] += 1;
  G_stats.topX_cl_alert[1] += infos->total_alerts;
}

int stats_clients(t_storage *client_storage, void *rien)
{
  G_stats.cl_number += 1;
  G_stats.srv_number += client_storage->second_list.elem_nb;
  G_stats.tcp_nb += client_storage->tcp_nb;
  G_stats.packet_rx += client_storage->packet_rx;
  G_stats.packet_tx += client_storage->packet_tx;
  G_stats.bytes_rx += client_storage->bytes_rx;
  G_stats.bytes_tx += client_storage->bytes_tx;
  G_stats.com_uptime += client_storage->com_uptime;
  
  return (0); // browse the whole list !
}

void stats_timeline(t_time_storage *time_storage)
{
  if (G_stats.stats_infos.time_first == 0 || 
      G_stats.stats_infos.time_first > time_storage->time_creation)
    G_stats.stats_infos.time_first = time_storage->time_creation;
  
  G_stats.stats_infos.delay += time_storage->period;
  G_stats.stats_infos.time_last = time_storage->time_creation+time_storage->period;
  G_stats.stats_infos.timeline_nb += 1;

  if (time_storage->client_number != 0)
    reverse_look_for_elem(&(time_storage->client_list),NULL,stats_clients);
}

int build_average_stats()
{
  int tmp;

  memset(&G_stats,0,sizeof(t_stats));

  browse_existing_elems(&(G_cctde_infos.time_list),stats_timeline);
  if (G_stats.stats_infos.time_first == 0) // There was no timeline
    {
      G_stats.stats_infos.time_first = G_cctde_infos.first_packet;
      G_stats.stats_infos.time_last = G_cctde_infos.last_packet;
      G_stats.stats_infos.delay = (G_cctde_infos.last_packet - G_cctde_infos.first_packet);
      reverse_look_for_elem(&(G_cctde_infos.client_list),NULL,stats_clients);
    }
  else // There was a timeline
    if (G_cctde_infos.client_list.elem_nb != 0) // and there are clients stored in main list
      {
	G_stats.stats_infos.delay += (G_cctde_infos.last_packet - 
				      get_start_period() - ROTATION_PERIOD());
	G_stats.stats_infos.time_last = G_cctde_infos.last_packet;
	reverse_look_for_elem(&(G_cctde_infos.client_list),NULL,stats_clients);
      }

  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_CON]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_SRV_con),stats_topxsrv_con);
  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_UPTIME]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_SRV_uptime),stats_topxsrv_uptime);
  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_PRX]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_SRV_prx),stats_topxsrv_prx);
  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_PTX]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_SRV_ptx),stats_topxsrv_ptx);
  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_BRX]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_SRV_brx),stats_topxsrv_brx);
  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_BTX]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_SRV_btx),stats_topxsrv_btx);
  if ((tmp = G_cctde_infos.config.conf_topX_srv[CF_MAX_ALERT]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_SRV_alert),stats_topxsrv_alert);

  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_CON]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_CL_con),stats_topxcl_con);
  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_UPTIME]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_CL_uptime),stats_topxcl_uptime);
  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_PRX]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_CL_prx),stats_topxcl_prx);
  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_PTX]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_CL_ptx),stats_topxcl_ptx);
  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_BRX]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_CL_brx),stats_topxcl_brx);
  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_BTX]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_CL_btx),stats_topxcl_btx);
  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_SRV]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_CL_srv),stats_topxcl_srv);
  if ((tmp = G_cctde_infos.config.conf_topX_cl[CF_MAX_ALERT]) != 0)
    browse_existing_elems(&(G_cctde_infos.TOPX_CL_alert),stats_topxcl_alert);

  return (1);
}
