/*
** CCTDE - Covert Channels and Tunnels Detection Engine - v0.2
** Copyright (C) 2003,2004 Simon Castro - scastro@entreelibre.com
**
** This file is part of CCTDE - v0.2 (C) 2003,2004 Simon Castro.
** 
** Cctde is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** Cctde is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with Cctde; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "../includes/cctde.h"

void stats_display_server_ip_port(t_storage *infos)
{
  display_infos(stdout,"%s:%d ",ip_uint_to_str(infos->ip),infos->port);
}

void stats_display_client_ip(t_storage *infos)
{
  display_infos(stdout,"%s ",ip_uint_to_str(infos->ip));
}

void display_stats_generic()
{
  double conv,conv2;

  display_infos(stdout,"    # There is %d clients and %d servers (not unique) :\n",
		G_stats.cl_number,G_stats.srv_number);
  display_infos(stdout,"      $ %d tcp connections for a %d secs com. uptime amount;\n",
		G_stats.tcp_nb,G_stats.com_uptime);

  conv = G_stats.packet_rx * 100;
  conv /= (G_stats.packet_rx+G_stats.packet_tx);
  conv2 = G_stats.packet_tx * 100;
  conv2 /= (G_stats.packet_rx+G_stats.packet_tx);
  display_infos(stdout,"      $ %d packets : %d packet_rx (%-2.2f%%) and %d packet_tx (%-2.2f%%);\n",
		G_stats.packet_rx+G_stats.packet_tx,G_stats.packet_rx,conv,G_stats.packet_tx,conv2);

  conv = G_stats.bytes_rx * 100;
  conv /= (G_stats.bytes_rx+G_stats.bytes_tx);
  conv2 = G_stats.bytes_tx * 100;
  conv2 /= (G_stats.bytes_rx+G_stats.bytes_tx);
  display_infos(stdout,"      $ %d bytes : %d bytes_rx (%-2.2f%%) and %d bytes_tx (%-2.2f%%);\n",
		G_stats.bytes_rx+G_stats.bytes_tx,G_stats.bytes_rx,conv,G_stats.bytes_tx,conv2);
}

void display_stats_topx_server()
{
  double conv,conv2;

  display_infos(stdout,"    # Tops Servers :\n");
  if (G_stats.topX_srv_tcp_nb[0] != 0)
    {
      conv = (G_stats.topX_srv_tcp_nb[1] * 100);
      conv /= G_stats.tcp_nb;
      display_infos(stdout,"      $ tcp_con(%d) : %d (%-2.2f%% of total con)\n",
		    G_stats.topX_srv_tcp_nb[0],G_stats.topX_srv_tcp_nb[1],conv);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_con),stats_display_server_ip_port,
				  G_stats.topX_srv_tcp_nb[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_srv_com_uptime[0] != 0)
    {
      conv = (G_stats.topX_srv_com_uptime[1] * 100);
      conv /= G_stats.com_uptime;
      display_infos(stdout,"      $ com_uptime(%d) : %d (%-2.2f%% of total uptime)\n",
		    G_stats.topX_srv_com_uptime[0],G_stats.topX_srv_com_uptime[1],conv);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_uptime),stats_display_server_ip_port,
				  G_stats.topX_srv_com_uptime[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_srv_packet_rx[0] != 0)
    {
      conv2 = conv = (G_stats.topX_srv_packet_rx[1] * 100);
      conv /= G_stats.packet_rx;
      conv2 /= (G_stats.packet_rx + G_stats.packet_tx);
      display_infos(stdout,"      $ packet_rx(%d) : %d (%-2.2f%% of total prx / %-2.2f%% of total packets)\n",
		    G_stats.topX_srv_packet_rx[0],G_stats.topX_srv_packet_rx[1],conv,conv2);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_prx),stats_display_server_ip_port,
				  G_stats.topX_srv_packet_rx[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_srv_packet_tx[0] != 0)
    {
      conv2 = conv = (G_stats.topX_srv_packet_tx[1] * 100);
      conv /= G_stats.packet_tx;
      conv2 /= (G_stats.packet_rx + G_stats.packet_tx);
      display_infos(stdout,"      $ packet_tx(%d) : %d (%-2.2f%% of total ptx / %-2.2f%% of total packets)\n",
		    G_stats.topX_srv_packet_tx[0],G_stats.topX_srv_packet_tx[1],conv,conv2);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_ptx),stats_display_server_ip_port,
				  G_stats.topX_srv_packet_tx[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_srv_bytes_rx[0] != 0)
    {
      conv2 = conv = (G_stats.topX_srv_bytes_rx[1] * 100);
      conv /= G_stats.bytes_rx;
      conv2 /= (G_stats.bytes_rx+G_stats.bytes_tx);
      display_infos(stdout,"      $ bytes_rx(%d) : %d (%-2.2f%% of total brx / %-2.2f%% of total bytes)\n",
		    G_stats.topX_srv_bytes_rx[0],G_stats.topX_srv_bytes_rx[1],conv,conv2);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_brx),stats_display_server_ip_port,
				  G_stats.topX_srv_bytes_rx[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_srv_bytes_tx[0] != 0)
    {
      conv2 = conv = (G_stats.topX_srv_bytes_tx[1] * 100);
      conv /= G_stats.bytes_tx;
      conv2 /= (G_stats.bytes_rx+G_stats.bytes_tx);
      display_infos(stdout,"      $ bytes_tx(%d) : %d (%-2.2f%% of total btx / %-2.2f%% of total bytes)\n",
		    G_stats.topX_srv_bytes_tx[0],G_stats.topX_srv_bytes_tx[1],conv,conv2);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_btx),stats_display_server_ip_port,
				  G_stats.topX_srv_bytes_tx[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_srv_alert[0] != 0)
    {
      display_infos(stdout,"      $ alert(%d) : %d\n",
		    G_stats.topX_srv_alert[0],G_stats.topX_srv_alert[1]);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_SRV_alert),stats_display_server_ip_port,
				  G_stats.topX_srv_alert[0]);
      display_infos(stdout,"\n");
    }
}


void display_stats_topx_client()
{
  double conv,conv2;

  display_infos(stdout,"    # Tops Clients :\n");
  if (G_stats.topX_cl_tcp_nb[0] != 0)
    {
      conv = (G_stats.topX_cl_tcp_nb[1] * 100);
      conv /= G_stats.tcp_nb;
      display_infos(stdout,"      $ tcp_con(%d) : %d (%-2.2f%% of total con)\n",
		    G_stats.topX_cl_tcp_nb[0],G_stats.topX_cl_tcp_nb[1],conv);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_con),stats_display_client_ip,
				  G_stats.topX_cl_tcp_nb[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_cl_com_uptime[0] != 0)
    {
      conv = (G_stats.topX_cl_com_uptime[1] * 100);
      conv /= G_stats.com_uptime;
      display_infos(stdout,"      $ com_uptime(%d) : %d (%-2.2f%% of total uptime)\n",
		    G_stats.topX_cl_com_uptime[0],G_stats.topX_cl_com_uptime[1],conv);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_uptime),stats_display_client_ip,
				  G_stats.topX_cl_com_uptime[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_cl_packet_rx[0] != 0)
    {
      conv2 = conv = (G_stats.topX_cl_packet_rx[1] * 100);
      conv /= G_stats.packet_rx;
      conv2 /= (G_stats.packet_rx + G_stats.packet_tx);
      display_infos(stdout,"      $ packet_rx(%d) : %d (%-2.2f%% of total prx / %-2.2f%% of total packets)\n",
		    G_stats.topX_cl_packet_rx[0],G_stats.topX_cl_packet_rx[1],conv,conv2);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_prx),stats_display_client_ip,
				  G_stats.topX_cl_packet_rx[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_cl_packet_tx[0] != 0)
    {
      conv2 = conv = (G_stats.topX_cl_packet_tx[1] * 100);
      conv /= G_stats.packet_tx;
      conv2 /= (G_stats.packet_rx + G_stats.packet_tx);
      display_infos(stdout,"      $ packet_tx(%d) : %d (%-2.2f%% of total ptx / %-2.2f%% of total packets)\n",
		    G_stats.topX_cl_packet_tx[0],G_stats.topX_cl_packet_tx[1],conv,conv2);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_ptx),stats_display_client_ip,
				  G_stats.topX_cl_packet_tx[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_cl_bytes_rx[0] != 0)
    {
      conv2 = conv = (G_stats.topX_cl_bytes_rx[1] * 100);
      conv /= G_stats.bytes_rx;
      conv2 /= (G_stats.bytes_rx+G_stats.bytes_tx);
      display_infos(stdout,"      $ bytes_rx(%d) : %d (%-2.2f%% of total brx / %-2.2f%% of total bytes)\n",
		    G_stats.topX_cl_bytes_rx[0],G_stats.topX_cl_bytes_rx[1],conv,conv2);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_brx),stats_display_client_ip,
				  G_stats.topX_cl_bytes_rx[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_cl_bytes_tx[0] != 0)
    {
      conv2 = conv = (G_stats.topX_cl_bytes_tx[1] * 100);
      conv /= G_stats.bytes_tx;
      conv2 /= (G_stats.bytes_rx+G_stats.bytes_tx);
      display_infos(stdout,"      $ bytes_tx(%d) : %d (%-2.2f%% of total btx / %-2.2f%% of total bytes)\n",
		    G_stats.topX_cl_bytes_tx[0],G_stats.topX_cl_bytes_tx[1],conv,conv2);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_btx),stats_display_client_ip,
				  G_stats.topX_cl_bytes_tx[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_cl_srv[0] != 0)
    {
      conv = (G_stats.topX_cl_srv[1] * 100);
      conv /= G_stats.srv_number;
      display_infos(stdout,"      $ srv(%d) : %d (%-2.2f%% of total servers)\n",
		    G_stats.topX_cl_srv[0],G_stats.topX_cl_srv[1],conv);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_srv),stats_display_client_ip,
				  G_stats.topX_cl_srv[0]);
      display_infos(stdout,"\n");
    }
  if (G_stats.topX_cl_alert[0] != 0)
    {
      display_infos(stdout,"      $ alert(%d) : %d\n",
		    G_stats.topX_cl_alert[0],G_stats.topX_cl_alert[1]);
      display_infos(stdout,"        ");
      browse_existing_elems_until(&(G_cctde_infos.TOPX_CL_alert),stats_display_client_ip,
				  G_stats.topX_cl_alert[0]);
      display_infos(stdout,"\n");
    }
}


void display_stats_approx()
{
  double conv=0,conv2=0;
  int i;

  display_infos(stdout,"    # Servers Approximations on TopX :\n");
  i = G_stats.stats_infos.delay / 60;

  if (G_stats.topX_srv_tcp_nb[0] != 0)
    {
      conv = (double) G_stats.topX_srv_tcp_nb[1] / G_stats.topX_srv_tcp_nb[0];
      conv2 = (double) (G_stats.topX_srv_tcp_nb[1] / G_stats.topX_srv_tcp_nb[0]) / i;
    }
  display_infos(stdout,"      $ For a %d secs period, tcp_con should be < %-2.2f, < %-2.2f (per min.)\n",
		G_stats.stats_infos.delay,conv,conv2);

  if (G_stats.topX_srv_com_uptime[0] != 0)
    {
      conv = (double) G_stats.topX_srv_com_uptime[1] / G_stats.topX_srv_com_uptime[0];
      conv2 = (double) (G_stats.topX_srv_com_uptime[1] / G_stats.topX_srv_com_uptime[0]) / i;
    }
  display_infos(stdout,"      $ For a %d secs period, com_uptime should be < %-2.2f, < %-2.2f (per min.)\n",
		G_stats.stats_infos.delay,conv,conv2);

  if (G_stats.topX_srv_packet_rx[0] != 0)
    {
      conv = (double) G_stats.topX_srv_packet_rx[1] / G_stats.topX_srv_packet_rx[0];
      conv2 = (double) (G_stats.topX_srv_packet_rx[1] / G_stats.topX_srv_packet_rx[0]) / i;
    }
  display_infos(stdout,"      $ For a %d secs period, packet_rx should be < %-2.2f, < %-2.2f (per min.)\n",
		G_stats.stats_infos.delay,conv,conv2);

  if (G_stats.topX_srv_packet_tx[0] != 0)
    {
      conv = (double) G_stats.topX_srv_packet_tx[1] / G_stats.topX_srv_packet_tx[0];
      conv2 = (double) (G_stats.topX_srv_packet_tx[1] / G_stats.topX_srv_packet_tx[0]) / i;
    }
  display_infos(stdout,"      $ For a %d secs period, packet_tx should be < %-2.2f, < %-2.2f (per min.)\n",
		G_stats.stats_infos.delay,conv,conv2);

  if (G_stats.topX_srv_bytes_rx[0] != 0)
    {
      conv = (double) G_stats.topX_srv_bytes_rx[1] / G_stats.topX_srv_bytes_rx[0];
      conv2 = (double) (G_stats.topX_srv_bytes_rx[1] / G_stats.topX_srv_bytes_rx[0]) / i;
    }
  display_infos(stdout,"      $ For a %d secs period, bytes_rx should be < %-2.2f, < %-2.2f (per min.)\n",
		G_stats.stats_infos.delay,conv,conv2);

  if (G_stats.topX_srv_bytes_tx[0] != 0)
    {
      conv = (double) G_stats.topX_srv_bytes_tx[1] / G_stats.topX_srv_bytes_tx[0];
      conv2 = (double) (G_stats.topX_srv_bytes_tx[1] / G_stats.topX_srv_bytes_tx[0]) / i;
    }
  display_infos(stdout,"      $ For a %d secs period, bytes_tx should be < %-2.2f, < %-2.2f (per min.)\n",
		G_stats.stats_infos.delay,conv,conv2);
}

int display_average_stats()
{

  display_infos(stdout,"\n  o Statistics :\n");
  display_infos(stdout,"    # Processed %d timelines",G_stats.stats_infos.timeline_nb);
  display_infos(stdout," (First is %s - Last is ",
		get_str_from_time_t(G_stats.stats_infos.time_first));
  display_infos(stdout,"%s)",get_str_from_time_t(G_stats.stats_infos.time_last));
  display_infos(stdout," (%d secs).\n",G_stats.stats_infos.delay);

  display_stats_generic();
  display_stats_topx_client();
  display_stats_topx_server();
  display_stats_approx();

  return (1);
}
